﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Text;

namespace FractalCompression
{
    public class FractalDecoder
    {
       
        int numRangeBlockPerRow;
        int numRangeBlocksPerColumn;
        int numRangeBlocksInPictureBlockRow;
        int faktor;
        Size PictureBlockSize;
        byte[,] outPixels;
        byte[,] temp;
        public static Size _rangeSize = new Size(4, 4);
        public static Size _domainSize=new Size(8,8);
        byte[,] picture;
        int noIterations = 10;
        bool _postProccess;
        public int NoIterations
        {
            get 
            { 
                return noIterations;
            }
            set
            { 
                noIterations = value;
            }
        }
        byte[] compacted;
        public FractalDecoder(bool postProccess)
        {
            _postProccess = postProccess;
            
        }
        public Bitmap getBitmap(string codedPath,int iterationNum)
        {
            faktor = 1;
            noIterations = iterationNum;

            Decode(codedPath);
            
            Bitmap result = new Bitmap(picture.GetLength(1), picture.GetLength(0));
            // CreatePicture(mappings);
            for (int i = 0; i < result.Height; i++)
            {
                for (int j = 0; j < result.Width; j++)
                {
                    result.SetPixel(j, i, Color.FromArgb(picture[i, j], picture[i, j], picture[i, j]));
                }
            }
            return result;
        }
        public void SavePicture(string codedPath, string outputPath)
        {
          /*  _rangeSize = new Size(8, 8);
            _domainSize = new Size(16, 16);
            faktor = 2;*/
            Bitmap result = getBitmap(codedPath, 10);
            result.Save(outputPath,ImageFormat.Jpeg);
        }
        private void postProcess(int numRangeBlockPerRow,int numRangeBlocksPerColumn)
        {
            int height=numRangeBlocksPerColumn*_rangeSize.Height;
            int width=numRangeBlockPerRow*_rangeSize.Width;
            int newA,newB;
            for(int i=_rangeSize.Width-1;i<width-1;i+=_rangeSize.Width)
            {
                for(int j=0;j<height;j++)
                {
                    newA=(int)((double)picture[j,i]*5/6+(double)picture[j,i+1]*1/6);
                    newB=(int)((double)picture[j,i]*1/6+(double)picture[j,i+1]*5/6);
                    picture[j,i]=(byte)newA;
                    picture[j,i+1]=(byte)newB;
                }
            }
            for(int i=_rangeSize.Width-1;i<height-1;i+=_rangeSize.Width)
            {
                for(int j=0;j<width;j++)
                {
                    newA=(int)((double)picture[i,j]*5/6+(double)picture[i+1,j]*1/6);
                    newB=(int)((double)picture[i,j]*1/6+(double)picture[i+1,j]*5/6);
                    picture[i,j]=(byte)newA;
                    picture[i+1,j]=(byte)newB;
                }
            }
        }




        public void SavePicture(List<FractalMap> mappings, string outputPath)
        {
            decodePart(mappings,0,0);
            
            Bitmap result = new Bitmap(outPixels.GetLength(1), outPixels.GetLength(0));
            // CreatePicture(mappings);
            for (int i = 0; i < result.Height; i++)
            {
                for (int j = 0; j < result.Width; j++)
                {
                    result.SetPixel(j, i, Color.FromArgb(outPixels[i, j], outPixels[i, j], outPixels[i, j]));
                }
            }
            
            result.Save(outputPath, ImageFormat.Bmp);
        }

        public void SavePicture2(string outputPath)
        {
         //   Decode(codedPath);
            Bitmap result = new Bitmap(outPixels.GetLength(1), outPixels.GetLength(0));
            // CreatePicture(mappings);
            for (int i = 0; i < result.Height; i++)
            {
                for (int j = 0; j < result.Width; j++)
                {
                    result.SetPixel(j, i, Color.FromArgb(outPixels[i, j], outPixels[i, j], outPixels[i, j]));
                }
            }
            result.Save(outputPath, ImageFormat.Bmp);
        }
        
        public void Decode(string path)
        {
            BinaryReader br=new BinaryReader(new FileStream(path,FileMode.Open));
            numRangeBlockPerRow=br.ReadInt16();
            numRangeBlocksPerColumn=br.ReadInt16();
            numRangeBlocksInPictureBlockRow=br.ReadInt16();
            
            compacted = br.ReadBytes((numRangeBlockPerRow * numRangeBlocksPerColumn * FractalMap.CompactLength) / 8 + 1);
            int bytePos = 0, bitPos = 0;
            PictureBlockSize = new Size(numRangeBlocksInPictureBlockRow * _rangeSize.Width, numRangeBlocksInPictureBlockRow * _rangeSize.Width);
            outPixels = new byte[numRangeBlocksInPictureBlockRow * _rangeSize.Height, numRangeBlocksInPictureBlockRow * _rangeSize.Width];
            temp = new byte[numRangeBlocksInPictureBlockRow * _rangeSize.Height, numRangeBlocksInPictureBlockRow * _rangeSize.Width];

            picture=new byte[numRangeBlockPerRow*_rangeSize.Width,numRangeBlocksPerColumn*_rangeSize.Height];
            for (int i = 0; i < picture.GetLength(0); i++)
            {
                for (int j = 0; j < picture.GetLength(1); j++)
                {
                    picture[i, j] = 128;
                }
            }
            
            int positionX = 0;
            int positionY = 0;
            int coordinateX=0;
            int coordinateY=0;
            int totalCount = numRangeBlockPerRow * numRangeBlocksPerColumn;
            int C = 0;
            double Yfaktor = 1;
            int xoff=0;
            int yoff=0;
            while(totalCount>0)
            {
                List<FractalMap> mappings=new List<FractalMap>();
                int count=numRangeBlocksInPictureBlockRow*numRangeBlocksInPictureBlockRow;
                
                if(positionX+numRangeBlocksInPictureBlockRow>numRangeBlockPerRow)
                {
                    count=(numRangeBlockPerRow%numRangeBlocksInPictureBlockRow)*numRangeBlocksInPictureBlockRow;
                    positionX = numRangeBlockPerRow-numRangeBlocksInPictureBlockRow;
                    xoff = positionX + numRangeBlocksInPictureBlockRow - numRangeBlockPerRow;
                }
                
                //else
                    
                

                if (positionX == 0)
                {
                  /*  count /= ;
                    count *= ;*/
                    xoff = 0;
                    if (positionY + numRangeBlocksInPictureBlockRow > numRangeBlocksPerColumn)
                    {
                        Yfaktor=(double)(numRangeBlocksPerColumn % numRangeBlocksInPictureBlockRow)/numRangeBlocksInPictureBlockRow;
                        positionY = numRangeBlocksPerColumn - numRangeBlocksInPictureBlockRow;
                        yoff = positionY + numRangeBlocksInPictureBlockRow - numRangeBlocksPerColumn;
                    }
                }
                count = (int)Math.Floor(count * Yfaktor);
                totalCount -= count;
                for(int i=0;i<count;i++)
                {
                    mappings.Add(new FractalMap(compacted,ref bytePos,ref bitPos));
                }


                coordinateX = positionX * _rangeSize.Width;
                coordinateY = positionY * _rangeSize.Height;
                for (int i = 0; i < PictureBlockSize.Height; i++)
                {
                    for (int j = 0; j < PictureBlockSize.Width; j++)
                    {

                        //outPixels[i, j] = (byte)R.Next(255);
                        outPixels[i, j] = picture[coordinateY + i, coordinateX + j];

                    }
                }
               // decodePart(mappings, xoff * _rangeSize.Width, yoff * _rangeSize.Height);
                decodePart(mappings, coordinateX%PictureBlockSize.Width, coordinateY%PictureBlockSize.Height);
            //    Console.ReadKey();
               
                for (int i = 0; i < outPixels.GetLength(0); i++)
                {
                    for (int j = 0; j < outPixels.GetLength(1); j++)
                    {
                        picture[coordinateY + i, coordinateX + j] = outPixels[i, j];
                    }
                }

               // SavePicture2("IZLAZ" + totalCount.ToString() + ".bmp");
                
                positionX = (positionX + numRangeBlocksInPictureBlockRow) % numRangeBlockPerRow;
                if (positionX == 0) positionY+=numRangeBlocksInPictureBlockRow;
                C++;
                Console.WriteLine(C);
                if (positionY >= numRangeBlocksPerColumn
                    )break ;
               


            }
            if(_postProccess)
                postProcess(numRangeBlockPerRow, numRangeBlocksPerColumn);
            br.Close();
        }

        private void decodePart(List<FractalMap> mappings,int xoff, int yoff)
        {
            
            
            for (int iteration = 0; iteration < noIterations; iteration++)
            {
                for (int i = 0; i < PictureBlockSize.Height; i++)
                {
                    for (int j = 0; j < PictureBlockSize.Width; j++)
                    {
                        temp[i, j] = outPixels[i, j];
                    }
                }
                //SavePicture2("IZLAZtemp.bmp");    
                for (int i = 0; i < mappings.Count; i++)
                {

                    //int Xcoord = xoff + i * _rangeSize.Width;
                    int Ycoord = yoff + (i * _rangeSize.Width) / (outPixels.GetLength(1) - xoff) * _rangeSize.Height;
                    int Xcoord = ((i * _rangeSize.Width) % (outPixels.GetLength(0) - xoff)) + xoff;
                    byte[,] rangeBuffer = transformToRangeBlock(outPixels, mappings[i].X*faktor, mappings[i].Y*faktor, mappings[i].Isometry/* Mappings[i].LumShift*/);
                    // byte[,] rangeBlock = getRangeBlock(pixels, i);
                    for (int j = 0; j < _rangeSize.Height; j++)
                    {
                        for (int k = 0; k < _rangeSize.Width; k++)
                        {

                            int val = ((int)(rangeBuffer[j, k] * mappings[i].Contrast) + mappings[i].LumShift);
                            temp[j + Ycoord
                                , k + Xcoord] = val < 255 ? (val < 0) ? (byte)0 : (byte)val : (byte)255;
                        }
                    }
                }
                byte[,] temp2 = outPixels;
                outPixels = temp;
                temp = temp2;
               // SavePicture2("IZLAZ" + iteration.ToString() + ".bmp");
             //   Console.ReadKey();
                //return outPixels;
            }
        }




        static byte[,] transformToRangeBlock(byte[,] input, int X, int Y, int isometry)
        {
            byte[,] result = new byte[_rangeSize.Height, _rangeSize.Width];
            int[,] temp = new int[_rangeSize.Height, _rangeSize.Width];
            int width = result.GetLength(0);
            int height = result.GetLength(1);
            int weightX = _domainSize.Width / _rangeSize.Width;
            int weightY = _domainSize.Height / _rangeSize.Height;
            int numElem = weightX * weightY;
            for (int i = 0; i < _domainSize.Height; i++)
            {
                for (int j = 0; j < _domainSize.Width; j++)
                {
                    temp[i / weightY, j / weightX] += input[Y + i, X + j];
                }
            }


            /*
                    int newLum = (domainBlock[i * 2, j * 2] + domainBlock[i * 2 + 1, j * 2] + domainBlock[i * 2, j * 2+1] + domainBlock[i * 2 + 1, j * 2+1]) / 4;
                 
                    newLum=newLum+ shift;
                    if (newLum > 255)
                    {
                        temp[i, j] = 255;
                    }
                    else if (newLum < 0)
                    {
                        temp[i, j] = 0;

                    }
                    else
                    {
                        temp[i, j] = (byte)newLum;
                    }
                }
            } 
            */
            #region isometricTransformAndShift
            switch (isometry)
            {
                case 0:
                    {
                        for (int i = 0; i < height; i++)
                        {
                            for (int j = 0; j < width; j++)
                            {
                                result[i, j] = (byte)(temp[i, j] / numElem);

                            }
                        }

                    } break;
                case 1:
                    {
                        for (int i = 0; i < height; i++)
                        {
                            for (int j = 0; j < width; j++)
                            {
                                result[i, j] = (byte)(temp[height - j - 1, i] / numElem);

                            }
                        }
                    } break;
                case 2:
                    {
                        for (int i = 0; i < height; i++)
                        {
                            for (int j = 0; j < width; j++)
                            {
                                result[i, j] = (byte)(temp[height - i - 1, height - j - 1] / numElem);

                            }
                        }
                    } break;
                case 3:
                    {
                        for (int i = 0; i < height; i++)
                        {
                            for (int j = 0; j < width; j++)
                            {
                                result[i, j] = (byte)(temp[j, height - i - 1] / numElem);

                            }
                        }
                    } break;
                case 4:
                    {
                        for (int i = 0; i < height; i++)
                        {
                            for (int j = 0; j < width; j++)
                            {
                                result[i, j] = (byte)(temp[height - j - 1, height - i - 1] / numElem);

                            }
                        }
                    } break;
                case 5:
                    {
                        for (int i = 0; i < height; i++)
                        {
                            for (int j = 0; j < width; j++)
                            {
                                result[i, j] = (byte)(temp[i, height - j - 1] / numElem);

                            }
                        }
                    } break;
                case 6:
                    {
                        for (int i = 0; i < height; i++)
                        {
                            for (int j = 0; j < width; j++)
                            {
                                result[i, j] = (byte)(temp[j, i] / numElem);

                            }
                        }
                    } break;
                case 7:
                    {
                        for (int i = 0; i < height; i++)
                        {
                            for (int j = 0; j < width; j++)
                            {
                                result[i, j] = (byte)(temp[height - i - 1, j] / numElem);

                            }
                        }
                    } break;
            }
            #endregion

            return result;
        }

    }
}
